#ifndef __CLASS_MAME_SOUND_H__
#define __CLASS_MAME_SOUND_H__

#include	<stdio.h>

#ifdef	__cplusplus

#include <GameKit.h>
#include <SupportKit.h>

class CCirculationIO : public BDataIO {
private:
	BLocker	f_locker;
	
	uint8*	f_buffer;
	int32	f_buffer_size;
	
	int32	f_w_pos;
	int32	f_r_pos;
	int32	f_n_pos;

public:
	CCirculationIO(size_t numBytes);
	~CCirculationIO();

	virtual	ssize_t	Read(void *buffer, size_t size);
	virtual	ssize_t	Write(const void *buffer, size_t size);

};

class CMAMESound : public BStreamingGameSound {
private:
	CCirculationIO*	f_buffer;

public:
	CMAMESound(size_t inBufferFrameCount, const gs_audio_format * format, size_t inBufferCount);
	~CMAMESound();

			void	Read(void *buffer, size_t size);
			void	Write(void *buffer, size_t size);
			
	static	void	Callback(void *cookie, void *inBuffer, size_t byteCount, BStreamingGameSound *object);

};

extern "C" {
#endif

int	open_be_sound(int channel, int rate, int sample_per_frame, int num_buffer);
void	close_be_sound(void);

void	copy_be_sound_buffer(void** buffer, int size);

void	set_be_sound_enable(int enable_it);

void	set_be_sound_volume(int volume);
int	get_be_sound_volume(void);

#ifdef	__cplusplus
}
#endif

#endif
