#include "mamalleg.h"
#include "driver.h"
#include "ticker.h"
#include <kernel/perfmon_user.h>

TICKER ticks_per_sec;

#if 1

TICKER ticker(void)
{
	INT64 result;
	__asm__ __volatile__ (
		"rdtsc"
		: "=A" (result)
	);
	return result;
}

void init_ticker(void)
{
	bigtime_t a,b;
	TICKER start, end;
	
	a = system_time();
	/* wait some time to let everything stabilize */
	do
	{
		b = system_time();
	} while ((b-a) < (1000000/10));

	a = system_time();
	start = ticker();
	do
	{
		b = system_time();
	} while ((b-a) < (1000000/4));
	end = ticker();
	ticks_per_sec = (end - start)*4;

logerror("using RDTSC for timing, CPU speed = %d.%06d MHz\n",
	(int)(ticks_per_sec/1000000),(int)(ticks_per_sec%1000000));
}

#else

TICKER ticker(void)
{
	return	(TICKER)system_time();
}

void init_ticker(void)
{
	ticks_per_sec = 1000000;
}

#endif